## deepin-deb-installer 6.0.19

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.7)
if (NOT DEFINED VERSION)
    message(WARNING "Not defined version ,about dialog version set 5.3.9")
    set(VERSION 5.3.9)
endif ()

find_package(GTest REQUIRED)
include_directories(${GTEST_INCLUDE_DIRS})
#common resource names
set(APP_RES_DIR "${CMAKE_SOURCE_DIR}/assets")
set(APP_BIN_NAME_TEST "deepin-deb-installer-test")
set(APP_TRANS_SCRIPT "${APP_RES_DIR}/translate_generation.sh")
set(APP_DESKTOP "${APP_RES_DIR}/deepin-deb-installer.desktop")
set(APP_QRC "${APP_RES_DIR}/resources.qrc")

project(${APP_BIN_NAME_TEST})


ADD_COMPILE_OPTIONS(-fno-access-control)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")

if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")

if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")

else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
  # -ffunction-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage")

#Generate the qm file
execute_process(COMMAND bash ${APP_TRANS_SCRIPT}
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/")

configure_file(${APP_RES_DIR}/environments.h.in environments.h @ONLY)

add_definitions(-DUSE_POLKIT -DENABLE_INACTIVE_DISPLAY)
# Find the library

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Test REQUIRED)
find_package(PolkitQt5-1 REQUIRED)


set(LINK_LIBS
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)

macro(SUBDIRLIST result curdir)
    file(GLOB children RELATIVE ${curdir} ${curdir}/*)
    set(dirlist "")
    foreach(child ${children})
        if(IS_DIRECTORY ${curdir}/${child})
            LIST(APPEND dirlist ${child})
        endif()
    endforeach()
    set(${result} ${dirlist})
endmacro()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src/deb-installer)

SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR}/../src/deb-installer/)

#Include all app own subdirectorys
foreach(subdir ${all_src})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}${subdir})
endforeach()

file(GLOB_RECURSE APP_SRCS
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/singleInstallerApplication.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/manager/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/model/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/utils/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/process/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/pages/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/widgets/*.cpp
    )
FILE(GLOB allTestSource
  src/*.cpp
  src/manager/*.cpp
  src/model/*.cpp
  src/utils/*.cpp
  src/view/pages/*.cpp
  src/view/widgets/*.cpp
)
include_directories(src)
include_directories( ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/)
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

# Tell CMake to create the executable
add_executable(${APP_BIN_NAME_TEST} ${APP_SRCS} ${APP_QRC} ${TEST_ACCESSIBLE_HEADERS_FILES}  ${allTestSource} )

target_include_directories(${APP_BIN_NAME_TEST}
    PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})


target_link_libraries(${APP_BIN_NAME_TEST}
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    PolkitQt5-1::Agent
    Qt5::Test
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${GTEST_LIBRARIES}
    ${GTEST_MAIN_LIBRARIES}
    pthread
)

#add_custom_target(test
#    COMMAND echo " =================== TEST BEGIN ==================== "
#    COMMAND ${CMAKE_BINARY_DIR}/tests/${APP_BIN_NAME_TEST}
#    COMMAND echo " =================== TEST END ==================== "
#)

=== src/deb-installer/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 - 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.7)
if (NOT DEFINED VERSION)
    message(WARNING "Not defined version ,about dialog version set 5.3.9")
    set(VERSION 5.3.9)
endif ()

#检查qapt版本
execute_process(COMMAND dpkg -s libqapt-dev
                COMMAND grep Version
                TIMEOUT 5
                OUTPUT_VARIABLE QAPT_VERSION_STR)
string(REPLACE "Version: " "" QAPT_VERSION_STR ${QAPT_VERSION_STR})
message(STATUS "BUILD QAPT VERSION ${QAPT_VERSION_STR}")

if(${QAPT_VERSION_STR} VERSION_LESS "3.0.5-1")
    if(${QAPT_VERSION_STR} VERSION_LESS "3.0.4.8-1+deepin2")
        message(STATUS "disable virtual package enhance")
    else()
        message(STATUS "enable virtual package enhance")
        add_definitions(-DENABLE_VIRTUAL_PACKAGE_ENHANCE)
    endif()
else()
    # 部分包名后可能添加后缀，后续更新的deepin分支libqapt包应包含虚包处理
    if(${QAPT_VERSION_STR} VERSION_GREATER_EQUAL "3.0.5.1-1-deepin1" AND ${QAPT_VERSION_STR} MATCHES ".*deepin.*")
        message(STATUS "enable virtual package enhance")
        add_definitions(-DENABLE_VIRTUAL_PACKAGE_ENHANCE)
    else()
        message(STATUS "disable virtual package enhance")
    endif()
endif()

#common resource names
set(APP_RES_DIR "${CMAKE_SOURCE_DIR}/assets")
set(APP_BIN_NAME "deepin-deb-installer")
set(APP_TRANS_SCRIPT "${APP_RES_DIR}/translate_generation.sh")
set(APP_DESKTOP "${APP_RES_DIR}/deepin-deb-installer.desktop")
set(APP_MIME "${APP_RES_DIR}/deepin-deb-installer.xml")
set(APP_QRC "${APP_RES_DIR}/resources.qrc")

project(${APP_BIN_NAME})

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "-Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")

  # 添加宏定义只在debug模式下输出性能打点日志
  add_definitions("-DDEBUG")

  if(CMAKE_SAFETYTEST)
  #安全测试选项
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fsanitize=undefined,address -O2")
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -g -fsanitize=undefined,address -O2")
    set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -g -fsanitize=undefined,address -O2")
    set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -g -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -g -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} -g -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}  -g -fsanitize=undefined,address -O2")
   endif()

else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
  # -ffunction-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -O2 -Wl,-O1 -Wl,--gc-sections")

endif()

#Generate the qm file
execute_process(COMMAND bash ${APP_TRANS_SCRIPT}
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/")

configure_file(${APP_RES_DIR}/environments.h.in environments.h @ONLY)

add_definitions(-DUSE_POLKIT -DENABLE_INACTIVE_DISPLAY)
# Find the library

find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(PolkitQt5-1 REQUIRED)
set(LINK_LIBS
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)

macro(SUBDIRLIST result curdir)
    file(GLOB children RELATIVE ${curdir} ${curdir}/*)
    set(dirlist "")
    foreach(child ${children})
        if(IS_DIRECTORY ${curdir}/${child})
            LIST(APPEND dirlist ${child})
        endif()
    endforeach()
    set(${result} ${dirlist})
endmacro()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR})

#Include all app own subdirectorys
foreach(subdir ${all_src})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}${subdir})
endforeach()

include_directories(${CMAKE_CURRENT_LIST_DIR}/utils)
file(GLOB_RECURSE APP_SRCS
    ${CMAKE_CURRENT_LIST_DIR}/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/manager/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/model/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/utils/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/process/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/view/pages/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/view/widgets/*.cpp
    )

include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

# Tell CMake to create the executable
add_executable(${PROJECT_NAME} ${APP_SRCS} ${APP_QRC})

target_include_directories(${APP_BIN_NAME}
    PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})

target_link_libraries(${APP_BIN_NAME}
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::DBus
    QApt
    Qt5::Concurrent
    PolkitQt5-1::Agent
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
)
set(CMAKE_INSTALL_PREFIX /usr)

# Install files
install(DIRECTORY ${APP_RES_DIR}/deepin-deb-installer DESTINATION /usr/share/deepin-manual/manual-assets/application/)
install(TARGETS deepin-deb-installer RUNTIME DESTINATION bin)
install(FILES ${APP_CONFIG} DESTINATION share/deepin-deb-installer)
install(FILES ${APP_DESKTOP} DESTINATION share/applications)
install(FILES ${APP_MIME} DESTINATION share/mime/packages)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/dbus/com.deepin.DebInstaller.service DESTINATION share/dbus-1/services/)

=== debian/changelog ===
deepin-deb-installer (6.0.19) unstable; urgency=medium

  * fix: Update qapt version check.
  * fix: Conflicts contain pkg name install failed.(Bug: 233895)

 -- renbin <renbin@uniontech.com> Tue, 12 Dec 2023 16:54:52 +0800

deepin-deb-installer (6.0.18) unstable; urgency=medium

  * fix: Fix package conflicts and replaces depends error.(Bug: 214693)(Influence: PackageInstall)
  * fix: Install wine package depends detection error.(Influence: Wine)
  * fix: Use depends package arch instead of deb file arch.(Bug: 220943)(Influence: DependsAnalysis)
  * fix: Check for dependency architecture error.(Bug: 220019)(Influence: Dependency)
  * fix: Remove check provides architecture.(Bug: 222531)
  * fix: Detect Provides/Or dependencies error.(Issue: #212307)(Influence: ProvidesDepends OrDepends)
  * fix: Print useless log after install failed.(Bug: 225161)
  * fix: or/provides depends error when first pkg fails.(Influence: ProvidesDepends)
  * fix: not responding to template settings input.(Influence: Templates)
  * fix: Optimize virtual pkg install strategy.(Bug: 229757)(Influence: VirtualPackage)

 -- renbin <renbin@uniontech.com>  Wed, 06 Dec 2023 13:22:46 +0800

deepin-deb-installer (6.0.14) unstable; urgency=medium

  * feat: Add application installation hierarchical verify policy.(Influence: Hierarchical)
  * fix: Change the way packages are checked for local path.(Influence: PackageVerify)
  * fix: Selecting multiple packages and pressing the Enter key cannot open the app.(Bug: 199167)(Influence: UI)
  * chore: Update translation settings and translation files.(Influence: Translation)
  * test: Add hierarchical control UT.(Influence: UT)
  * feat: Add hierarchical setting prompt.(Task: 28999)(Influence: Hierarchical)
  * chore: Add hierarchical setting prompt translation.(Task: 28999)(Influence: Translation)
  * test: Add hierarchical notify unit test case.(Influence: UnitTest)
  * fix: Use Event() update palette.(Influence: UpdatePalette)
  * fix: Remove package will remove "breaks" reverse depends.(Bug: 208617)(Influence: UninstallPcakge)
  * fix: Read QLatin1String returned from QApt may be freed.(Influence: CheckConflict)
  * fix: Wrong architecture used while install wine package.(Bug: 205805)(Influence: WineDepends)
  * fix: Jump to develop mode page instand of common info page.(Bug: 209873)(Influence: DevelopMode)
  * fix: Dialog text disappear when using large font size.(Bug: 201611)(Influence: DialogText)
  * fix: UI diff for single-page and multi-page.(Bug: 193971)(Influence: UI)
  * fix: Adjust layout spacing and margins.(Bug: 193969, 193153, 193205, 157603)(Influence: UI)

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 31 Jul 2023 10:13:04 +0800

deepin-deb-installer (6.0.10) unstable; urgency=medium

  * fix: 修复libqapt包名带后缀无法准确区分版本的问题(Bug: 195557)(Influence: 虚包安装依赖)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 12 Apr 2023 12:27:31 +0800

deepin-deb-installer (6.0.9) unstable; urgency=medium

  * fix: 移除安装依赖 deepin-elf-verify(Bug: 195557)(Influence: 安装依赖)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 12 Apr 2023 09:52:04 +0800

deepin-deb-installer (6.0.8) unstable; urgency=medium

  * fix: 移除对 deepin-elf-sign-tool 的强依赖(Influence: 安装依赖)

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 07 Apr 2023 15:59:52 +0800

deepin-deb-installer (6.0.5) unstable; urgency=medium

  * Update version

 -- wangzhengyang <wangzhengyang@uniontech.com>  Thu, 30 Mar 2023 17:19:43 +0800

deepin-deb-installer (6.0.4) unstable; urgency=medium

  * Update version

 -- wangzhengyang <wangzhengyang@uniontech.com>  Fri, 10 Mar 2023 10:59:41 +0800

deepin-deb-installer (6.0.3) unstable; urgency=medium

  * Add check for wine depend install

 -- wangzhengyang <wangzhengyang@uniontech.com>  Tue, 21 Feb 2023 13:38:35 +0800

deepin-deb-installer (6.0.1) unstable; urgency=medium

  * Merge version to 6.0.1
  * Add DDIM routine

 -- wangzhengyang <wangzhengyang@uniontech.com>  Thu, 14 Feb 2023 15:07:35 +0800

=== debian/control ===
Source: deepin-deb-installer
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>= 9), pkg-config, cmake, libqt5widgets5, libqt5concurrent5, libqapt-dev, libdtkwidget-dev, qtbase5-dev, qttools5-dev-tools, qttools5-dev, qtchooser, libgtest-dev,  deepin-gettext-tools,  libpolkit-qt5-1-dev
Standards-Version: 4.3.0
Homepage: https://www.deepin.com/

Package: deepin-deb-installer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqapt3-runtime, libqapt3
Description: Package Installer helps users install and remove local packages.
 Package Installer is an easy-to-use .deb package management tool 
 with a simple interface for users to quickly install customized applications
 not included in App Store supporting bulk installation, version identification
 and auto completion.
Recommends: uos-reporter, deepin-event-log

## deepin-deb-installer 6.5.0

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -137,6 +137,8 @@
     ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/process/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/pages/*.cpp
     ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/widgets/*.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/uab/*.cpp
+    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/compatible/*.cpp
     )
 FILE(GLOB allTestSource
   src/*.cpp
@@ -145,6 +147,7 @@
   src/utils/*.cpp
   src/view/pages/*.cpp
   src/view/widgets/*.cpp
+  src/uab/*.cpp
 )
 include_directories(src)
 include_directories( ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/)

=== src/AptInstallDepend/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.13)

if (NOT DEFINED VERSION)
    set(VERSION 5.3.9)
endif ()

project(AptInstallDepend)
set (EXE_NAME deepin-deb-installer-dependsInstall)
set(LINK_LIBS
    Qt5::Core
)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

#add process directories
string(REGEX REPLACE "(.*)/(.*)" "\\1" PROJECT_INIT_PATH  ${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_INIT_PATH}/deb-installer/process)

file(GLOB_RECURSE AUTH_CPP_FILES ${CMAKE_CURRENT_LIST_DIR}/*.h ${CMAKE_CURRENT_LIST_DIR}/*.cpp ${PROJECT_INIT_PATH}/deb-installer/process/*.cpp)
add_executable (${EXE_NAME}
    ${AUTH_CPP_FILES}
)

# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Core REQUIRED)
set(CMAKE_INSTALL_PREFIX /usr)
# Install files
install(TARGETS ${EXE_NAME} DESTINATION bin)
target_link_libraries(${EXE_NAME} ${LINK_LIBS} )
target_link_libraries(${EXE_NAME}
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui)

=== src/deb-installer/CMakeLists.txt ===
--- 
+++ 
@@ -158,13 +158,8 @@
 
 include_directories(${CMAKE_CURRENT_LIST_DIR}/utils)
 file(GLOB_RECURSE APP_SRCS
+    ${CMAKE_CURRENT_LIST_DIR}/*.h
     ${CMAKE_CURRENT_LIST_DIR}/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/manager/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/model/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/utils/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/process/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/view/pages/*.cpp
-    ${CMAKE_CURRENT_LIST_DIR}/view/widgets/*.cpp
     )
 
 include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

=== src/deepin-deb-installer-dev/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.13)

if (NOT DEFINED VERSION)
    set(VERSION 5.3.9)
endif ()
set(APP_BIN_NAME "libdeepin-deb-installer")

project(deepin-deb-installer-dev)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

find_package(PkgConfig REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5DBus REQUIRED)

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    QApt
    Qt5::Concurrent
)
include_directories(${CMAKE_CURRENT_LIST_DIR})
file(GLOB_RECURSE APP_SRCS
    ${CMAKE_CURRENT_LIST_DIR}/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/manager/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/installer/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/package/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/status/*.cpp
    )

file(GLOB_RECURSE APP_INCLUDE
    ${CMAKE_CURRENT_LIST_DIR}/deepin-deb-installer-lib_global.h
    ${CMAKE_CURRENT_LIST_DIR}/DeepinDebInstallerLib.h
    )

add_library( ${APP_BIN_NAME} SHARED ${APP_SRCS})

# Find the library
target_link_libraries(${APP_BIN_NAME}
    Qt5::Core
    Qt5::DBus
    QApt
    Qt5::Concurrent
)

set(CMAKE_INSTALL_PREFIX /usr)
# Install files

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

SET_TARGET_PROPERTIES(${APP_BIN_NAME} PROPERTIES VERSION 1.0.0 SOVERSION 1)

install(TARGETS ${APP_BIN_NAME} LIBRARY DESTINATION lib)

install(FILES ${APP_INCLUDE} DESTINATION  include/deepin-deb-installer)

execute_process(COMMAND "ldconfig")

=== debian/changelog ===
deepin-deb-installer (6.5.0) unstable; urgency=medium

  * chore: Add comment details.
  * fix: Error message during installation(Bug: 258605)
  * chore(CI): add debian check workflow
  * fix: Set default focus widget on each page(Bug: 247435)(Influence: FocusWidget)
  * fix: UI init wrong when load large package(Bug: 247435)(Influence: FocusWidget)
  * fix: Change default focus widget(Bug: 247435, 248153, 248161)(Influence: FocusWidget)
  * fix: Remove clear focus code(Bug: 247435)(Influence: FocusWidget)
  * fix: Button focus not work in wayland(Bug: 247435)
  * fix: The effect of checkbox is not fully displayed(Bug: 248145)(Influence: UI)
  * docs: update readme.md
  * fix: update hierarchical verify code(Bug: 269341)
  * feat: deepin-elf-verify or depends(Influence: debian/control)
  * style: apply clang format
  * refactor: abstract package model interface
  * feat: uab package backend(Influence: uab-backend)
  * feat: uab package process controller(Influence: uab-package)
  * feat: [translation]add transifex config(Task: 361363)
  * feat: uab package list model(Influence: uab-package)
  * feat: mixed deb/uab pacakge installation.(Influence: uab-package)
  * feat: commit changes to uab backend(Influence: uab-package)
  * feat: check linglong env and json parser(Influence: uab-package)
  * refactor: update the installer dbus interface(Influence: uab-package)
  * fix: tip for installation process
  * feat: support dbus package manager interface(Influence: uab-package)
  * feat: add uab icon(Influence: uab-package)
  * refactor: update uab append fails tips(Influence: uab-package)
  * feat: support select uab file
  * chore: update chinese translations
  * fix: update uab mimetype and uninstall process
  * fix: compatible fixes
  * fix: failed to detect replaceable packages(Bug: 275221)
  * fix: init flag before check 'or depends'(Bug: 275221)
  * fix: disable providesEnhance in the community edition
  * feat: add uab icon and fix loop call(Influence: uab-package)
  * fix: adapt compact mode(Bug: 279783)(Influence: compact-mode)
  * test: fix some outdated unit tests.
  * feat: adapt compatible install(Influence: compatible)
  * feat: add compatible backend(Influence: compatible)
  * feat: adapt package model with compatibility mode(Influence: compatible)
  * feat: adapt compatibility mode ui(Influence: compatible)
  * fix: update the prompt info(Influence: compatible)
  * feat: compatibility mode support debconf and verify.(Influence: compatible)
  * fix: add display of packages to be removed(Bug: 275401)
  * chore: update translation(Influence: translation)

 -- renbin <renbin@uniontech.com>  Thu, 31 Oct 2024 16:03:40 +0800

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,12 @@
 
 Package: deepin-deb-installer
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libqapt3-runtime, libqapt3
+Depends: ${shlibs:Depends}, ${misc:Depends}, 
+ libqapt3-runtime, 
+ libqapt3, 
+# deepin-app-store-runtime is available in the community edition.
+ deepin-elf-verify | deepin-app-store-runtime, 
+ deepin-elf-sign-tool | deepin-app-store-runtime
 Description: Package Installer helps users install and remove local packages.
  Package Installer is an easy-to-use .deb package management tool 
  with a simple interface for users to quickly install customized applications

## deepin-deb-installer 6.5.5

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.13)

if(NOT DEFINED VERSION)
    set(VERSION 5.3.9)
endif()

# 安全测试的开关
set(CMAKE_SAFETYTEST OFF)

project(deepin_deb_installer)
option(DMAN_RELEAE OFF "Install dman resources to system or not")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
# 引入翻译生成
include(translation-generate)

# Find Qt version
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
message("   >>> Found Qt version: ${QT_VERSION_MAJOR}")
set(QT_DESIRED_VERSION ${QT_VERSION_MAJOR})

if (QT_VERSION_MAJOR MATCHES 6)
    set(DTK_VERSION_MAJOR 6)
else()
    set(DTK_VERSION_MAJOR "")
endif()
message("   >>> Build with DTK: ${DTK_VERSION_MAJOR}")

if (QT_DESIRED_VERSION MATCHES 6)
    find_package(QApt-qt6 REQUIRED)
    include_directories(${QApt-qt6_INCLUDE_DIRS})
    set(QAPT_LIB QApt-qt6)
else()
    find_package(QApt REQUIRED)
    include_directories(${QApt_INCLUDE_DIRS})
    set(QAPT_LIB QApt)
endif()

add_subdirectory(src/AptInstallDepend)
add_subdirectory(src/deb-installer)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_subdirectory(tests)
endif()

add_subdirectory(src/deepin-deb-installer-dev)

set(POLICY_FILE com.deepin.pkexec.aptInstallDepend.policy)
add_subdirectory(translations/policy)

# add_subdirectory(tests/FuzzyTest)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.7)

if(NOT DEFINED VERSION)
    message(WARNING "Not defined version ,about dialog version set 5.3.9")
    set(VERSION 5.3.9)
endif()

find_package(GTest REQUIRED)
include_directories(${GTEST_INCLUDE_DIRS})

# common resource names
set(APP_RES_DIR "${CMAKE_SOURCE_DIR}/assets")
set(APP_BIN_NAME_TEST "deepin-deb-installer-test")
set(APP_DESKTOP "${APP_RES_DIR}/deepin-deb-installer.desktop")
set(APP_QRC "${APP_RES_DIR}/resources.qrc")

project(${APP_BIN_NAME_TEST})

ADD_COMPILE_OPTIONS(-fno-access-control)

set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")

# 安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")

if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")

if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
    # 安全测试选项
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

# compile flags
if(CMAKE_BUILD_TYPE MATCHES Debug)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

    # Enable Qt builtin debug mode
    add_definitions("-DQT_MESSAGELOGCONTEXT")

else()
    # -Wl, -O2 Enable linker optimizations
    # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
    # -ffunction-sections
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage")


configure_file(${APP_RES_DIR}/environments.h.in environments.h @ONLY)

add_definitions(-DUSE_POLKIT -DENABLE_INACTIVE_DISPLAY)

# Find the library
find_package(PkgConfig REQUIRED)

find_package(PolkitQt${QT_DESIRED_VERSION}-1)
set(qt_required_components Core DBus Gui Widgets Concurrent Test)

if (QT_DESIRED_VERSION MATCHES 6)
    list(APPEND qt_required_components Core5Compat)
endif()

find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS ${qt_required_components})
find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Core Gui Widget REQUIRED)

set(LINK_LIBS
    Qt${QT_DESIRED_VERSION}::Core
    Qt${QT_DESIRED_VERSION}::DBus
    Qt${QT_DESIRED_VERSION}::Gui
    Qt${QT_DESIRED_VERSION}::Widgets
    Qt${QT_DESIRED_VERSION}::Concurrent
    Qt${QT_DESIRED_VERSION}::Test
    Dtk${DTK_VERSION_MAJOR}::Widget
    Dtk${DTK_VERSION_MAJOR}::Core
    Dtk${DTK_VERSION_MAJOR}::Gui
    PolkitQt${QT_DESIRED_VERSION}-1::Agent
)

if (QT_DESIRED_VERSION MATCHES 6)
    list(APPEND LINK_LIBS Qt${QT_DESIRED_VERSION}::Core5Compat)
endif()

macro(SUBDIRLIST result curdir)
    file(GLOB children RELATIVE ${curdir} ${curdir}/*)
    set(dirlist "")

    foreach(child ${children})
        if(IS_DIRECTORY ${curdir}/${child})
            LIST(APPEND dirlist ${child})
        endif()
    endforeach()

    set(${result} ${dirlist})
endmacro()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src/deb-installer)

SUBDIRLIST(all_src ${CMAKE_CURRENT_SOURCE_DIR}/../src/deb-installer/)

# Include all app own subdirectorys
foreach(subdir ${all_src})
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}${subdir})
endforeach()

file(GLOB_RECURSE APP_SRCS
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/singleInstallerApplication.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/manager/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/model/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/utils/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/process/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/pages/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/view/widgets/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/uab/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/compatible/*.cpp
    ${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/immutable/*.cpp
)
FILE(GLOB allTestSource
    src/*.cpp
    src/manager/*.cpp
    src/model/*.cpp
    src/utils/*.cpp
    src/view/pages/*.cpp
    src/view/widgets/*.cpp
    src/uab/*.cpp
)
include_directories(src)
include_directories(${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/)

# Tell CMake to create the executable
add_executable(${APP_BIN_NAME_TEST} ${APP_SRCS} ${APP_QRC} ${TEST_ACCESSIBLE_HEADERS_FILES} ${allTestSource})


target_link_libraries(${APP_BIN_NAME_TEST}
    PUBLIC
    ${LINK_LIBS}
    ${QAPT_LIB}
    ${GTEST_LIBRARIES}
    ${GTEST_MAIN_LIBRARIES}
    pthread
)

# add_custom_target(test
# COMMAND echo " =================== TEST BEGIN ==================== "
# COMMAND ${CMAKE_BINARY_DIR}/tests/${APP_BIN_NAME_TEST}
# COMMAND echo " =================== TEST END ==================== "
# )

=== src/AptInstallDepend/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 - 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.13)

if(NOT DEFINED VERSION)
    set(VERSION 5.3.9)
endif()

project(AptInstallDepend)
set(EXE_NAME deepin-deb-installer-dependsInstall)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

# 安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

# add process directories
string(REGEX REPLACE "(.*)/(.*)" "\\1" PROJECT_INIT_PATH ${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_INIT_PATH}/deb-installer/process)

file(GLOB_RECURSE AUTH_CPP_FILES
    ${CMAKE_CURRENT_LIST_DIR}/*.h
    ${CMAKE_CURRENT_LIST_DIR}/*.cpp
    ${PROJECT_INIT_PATH}/deb-installer/process/*.cpp)
add_executable(${EXE_NAME}
    ${AUTH_CPP_FILES}
)

# Find the library
set(qt_required_components Core Gui Widgets)

if (QT_DESIRED_VERSION MATCHES 6)
    list(APPEND qt_required_components Core5Compat)
endif()
find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS ${qt_required_components})

set(LINK_LIBS
    Qt${QT_DESIRED_VERSION}::Core
    Qt${QT_DESIRED_VERSION}::Gui
    Qt${QT_DESIRED_VERSION}::Widgets
)

if (QT_DESIRED_VERSION MATCHES 6)
    list(APPEND LINK_LIBS Qt${QT_DESIRED_VERSION}::Core5Compat)
endif()

set(CMAKE_INSTALL_PREFIX /usr)

# Install files
install(TARGETS ${EXE_NAME} DESTINATION bin)
target_link_libraries(${EXE_NAME}
    PUBLIC
    ${LINK_LIBS}
    )

=== src/deepin-deb-installer-dev/CMakeLists.txt ===
--- 
+++ 
@@ -18,16 +18,21 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
 
 find_package(PkgConfig REQUIRED)
-find_package(Qt5Core REQUIRED)
-find_package(Qt5Concurrent REQUIRED)
-find_package(Qt5DBus REQUIRED)
+
+set(qt_required_components Core DBus Concurrent)
+
+if (QT_DESIRED_VERSION MATCHES 6)
+    list(APPEND qt_required_components Core5Compat)
+endif()
+
+find_package(Qt${QT_DESIRED_VERSION} REQUIRED COMPONENTS ${qt_required_components})
 
 set(LINK_LIBS
-    Qt5::Core
-    Qt5::DBus
-    QApt
-    Qt5::Concurrent
+    Qt${QT_DESIRED_VERSION}::Core
+    Qt${QT_DESIRED_VERSION}::DBus
+    Qt${QT_DESIRED_VERSION}::Concurrent
 )
+
 include_directories(${CMAKE_CURRENT_LIST_DIR})
 file(GLOB_RECURSE APP_SRCS
     ${CMAKE_CURRENT_LIST_DIR}/*.cpp
@@ -46,10 +51,9 @@
 
 # Find the library
 target_link_libraries(${APP_BIN_NAME}
-    Qt5::Core
-    Qt5::DBus
-    QApt
-    Qt5::Concurrent
+    PRIVATE
+    ${LINK_LIBS}
+    ${QAPT_LIB}
 )
 
 set(CMAKE_INSTALL_PREFIX /usr)

=== tests/FuzzyTest/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier:CC0-1.0

cmake_minimum_required(VERSION 3.9.5)


set(EXE_LIBQAPT_NAME libqapt_test)

project(EXE_LIBQAPT_NAME)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_C_COMPILER /usr/bin/clang)
set(CMAKE_CXX_COMPILER /usr/bin/clang++)

include(FindPkgConfig)
pkg_check_modules(MOD_GOBJECT REQUIRED gobject-2.0)

find_package(Qt5 COMPONENTS Core Widgets Gui REQUIRED )


file(GLOB_RECURSE SRC_LIST FOLLOW_SYMLINKS LIST_DIRECTORIES false ${PROJECT_SOURCE_DIR}/src/*.cpp)
file(GLOB_RECURSE INC_LIST FOLLOW_SYMLINKS LIST_DIRECTORIES false ${PROJECT_SOURCE_DIR}/src/*.h)
file(GLOB_RECURSE HEAD_LIST FOLLOW_SYMLINKS LIST_DIRECTORIES false ${PROJECT_SOURCE_DIR}/include/*.h)
list(APPEND INC_LIST ${HEAD_LIST})

add_executable(${EXE_LIBQAPT_NAME} ${SRC_LIST})

target_include_directories(${EXE_LIBQAPT_NAME}
    PRIVATE Qt5::Core Qt5::Widgets Qt5::Gui )

target_link_libraries(${EXE_LIBQAPT_NAME}
    PRIVATE Qt5::Core Qt5::Widgets Qt5::Gui)

target_compile_options(${EXE_LIBQAPT_NAME}
    PRIVATE -g -std=c++11)

target_link_options(${EXE_LIBQAPT_NAME}
    PRIVATE -fsanitize=undefined,address,leak -fsanitize=fuzzer)

target_include_directories(${EXE_LIBQAPT_NAME}
    PRIVATE ${MOD_ATSPI2_INCLUDE_DIRS}
    PRIVATE ${MOD_GOBJECT_INCLUDE_DIRS}
    )

target_link_libraries(${EXE_LIBQAPT_NAME}
    PRIVATE ${MOD_ATSPI2_LIBRARIES}
    PRIVATE ${MOD_GOBJECT_LIBRARIES}
    PRIVATE libFuzzer.a
    PRIVATE pthread
    QApt)
target_link_directories(${EXE_LIBQAPT_NAME}
    PRIVATE ${MOD_ATSPI2_LIBRARY_DIRS}
    PRIVATE ${MOD_GOBJECT_LIBRARY_DIRS}
    PRIVATE ${PROJECT_SOURCE_DIR}/thirdlib
    )
set(LINK_LIBS
    QApt
)

=== debian/changelog ===
deepin-deb-installer (6.5.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control: Update build-dep accordingly.
  * debian/patches: Dropped.

 -- Boyuan Yang <byang@debian.org>  Tue, 11 Feb 2025 20:04:51 -0500

deepin-deb-installer (5.12.4-3) unstable; urgency=medium

  * Add patch to use cxx17. (Closes: #1090206)

 -- Arun Kumar Pariyar <arun@debian.org>  Sat, 28 Dec 2024 18:26:33 +0545

=== debian/control ===
Source: deepin-deb-installer
Section: utils
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yanhao Mo <yanhaocs@gmail.com>,
 Clay Stan <claystan97@gmail.com>,
 Arun Kumar Pariyar <arun@debian.org>,
 Nisha Pariyar <nishapariyar48@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 deepin-gettext-tools,
 libdtkcore-dev (>= 5.7.6),
 libdtkwidget-dev (>= 5.7.6),
 libgtest-dev,
 libpolkit-qt5-1-dev,
 libqapt-dev,
 libqt5svg5-dev,
 pkgconf,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/linuxdeepin/deepin-deb-installer
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-deb-installer

Package: deepin-deb-installer
Architecture: any
Depends:
 libqapt3-runtime,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin Package Manager
 Deepin Package Manager is a management tool for deb package, and is developed
 for users to easily install customized applications that are not categorized
 in Deepin Store. With an easy-to-use interface as well as functions like batch
 installation, version detection and auto-completion of dependencies, you can
 quickly get the software installed on deepin once you get the right deb
 package.
 .
 This package is part of DDE (Deepin Desktop Environment).

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

export QT_SELECT := 5

include /usr/share/dpkg/default.mk


%:
	dh $@ --buildsystem=cmake --no-parallel

override_dh_auto_configure:
	dh_auto_configure -- -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM)

execute_after_auto_clean:
	find translations -type f -name *.qm -delete

## deepin-deb-installer 6.5.18

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -151,6 +151,7 @@
     src/view/pages/*.cpp
     src/view/widgets/*.cpp
     src/uab/*.cpp
+    src/compatible/*.cpp
 )
 include_directories(src)
 include_directories(${CMAKE_CURRENT_LIST_DIR}/../src/deb-installer/)

=== debian/changelog ===
deepin-deb-installer (6.5.18) unstable; urgency=medium

  *  Update version to 6.5.18.

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 08 May 2025 19:33:23 +0800

deepin-deb-installer (6.5.17) unstable; urgency=medium

  * fix: memory leak (#328)(Bug: 311727)

 -- renbin <renbin@uniontech.com>  Tue, 29 Apr 2025 17:48:33 +0800

deepin-deb-installer (6.5.16) unstable; urgency=medium

  * fix: Remove outdated mimetype "application-x-uab"
  * fix: Add parent to QStandardItemModel
  * fix: Enhance remote file detection(Bug: 313783)

 -- renbin <renbin@uniontech.com>  Thu, 24 Apr 2025 17:14:11 +0800

deepin-deb-installer (6.5.15) unstable; urgency=medium

  * chore: update translations.

 -- renbin <renbin@uniontech.com>  Thu, 17 Apr 2025 09:39:21 +0800

deepin-deb-installer (6.5.14) unstable; urgency=medium

  * chore: update translations
  * fix: support url(Bug: 312003)
  * fix: Fix dependency removal in graph(Bug: 311897)

 -- renbin <renbin@uniontech.com>  Thu, 10 Apr 2025 16:06:15 +0800

deepin-deb-installer (6.5.13) unstable; urgency=medium

  * chore: update desktop file
  * feat: adapt new black list config file path(Task: 374685)

 -- renbin <renbin@uniontech.com>  Wed, 02 Apr 2025 15:44:58 +0800

deepin-deb-installer (6.5.12) unstable; urgency=medium

  * fix: wrong linked package name(Bug: 309051)
  * fix: optimize symbolic link file naming logic(Bug: 309051)

 -- renbin <renbin@uniontech.com>  Thu, 27 Mar 2025 16:56:59 +0800

deepin-deb-installer (6.5.11) unstable; urgency=medium

  * i18n: Updates for project Deepin Package Installer (#306)
  * fix: remove duplicate package status detections.(Bug: 307921)
  * [skip CI] Translate deepin-deb-installer.ts in ja
  * fix: remove unnecessary check(Bug: 307705)
  * fix: skip first package check if cached.(Bug: 307705)

 -- renbin <renbin@uniontech.com>  Thu, 20 Mar 2025 19:03:46 +0800

deepin-deb-installer (6.5.10) unstable; urgency=medium

  * fix: can not downgrades(Bug: 305705)
  * fix: get rootfs list incorrect(Bug: 306523)
  * chore: update translations.(Bug: 306531)

 -- renbin <renbin@uniontech.com>  Thu, 06 Mar 2025 19:04:14 +0800

deepin-deb-installer (6.5.9) unstable; urgency=medium

  * feat: support uab mimetype

 -- renbin <renbin@uniontech.com>  Fri, 28 Feb 2025 14:26:36 +0800

deepin-deb-installer (6.5.8) unstable; urgency=medium

  * i18n: Updates for project Deepin Package Installer (#298)
  * fix: app hangs when install uab without linglong(Bug: 292077)

 -- renbin <renbin@uniontech.com>  Thu, 27 Feb 2025 19:13:38 +0800

deepin-deb-installer (6.5.7) unstable; urgency=medium

  * fix: init rootfs first

 -- renbin <renbin@uniontech.com>  Thu, 20 Feb 2025 20:50:21 +0800

deepin-deb-installer (6.5.6) unstable; urgency=medium

  * fix: no install log output(Bug: 303125)
  * feat: Add app compatibility check and enhance compatible mode

 -- renbin <renbin@uniontech.com>  Thu, 20 Feb 2025 19:36:26 +0800

deepin-deb-installer (6.5.5) unstable; urgency=medium

  * chore: v6.5.5 release.
  * fix: Update qapt version check.
  * feat: Enable support Qt6 build.

 -- re2zero <yangwu@uniontech.com>  Mon, 20 Jan 2025 16:30:43 +0800

deepin-deb-installer (6.5.4) unstable; urgency=medium

  * feat: Enable support Qt6 build.

 -- re2zero <yangwu@uniontech.com>  Fri, 3 Jan 2025 16:27:05 +0800

deepin-deb-installer (6.5.3) unstable; urgency=medium

  * fix: assume yes in immutable install(Bug: 291783)(Influence: immutable)
  * fix: get uab meta info failed(Bug: 292129)(Influence: uab-package)
  * fix: blocked when uninstall(Bug: 291783)
  * fix: change tips color when theme changed(Bug: 292139)(Influence: UI)
  * feat: update immutable config

 -- renbin <renbin@uniontech.com>  Sat, 07 Dec 2024 11:56:09 +0800

deepin-deb-installer (6.5.2) unstable; urgency=medium

  * feat: uab installation add authentication(Task: 36033)(Influence: uab-package)
  * chore: add comments
  * chore: format cmakelists.txt
  * fix: uab use absolute path(Influence: uab-pacakge)

 -- renbin <renbin@uniontech.com>  Sat, 30 Nov 2024 13:16:30 +0800

deepin-deb-installer (6.5.1) unstable; urgency=medium

  * feat: temporarily disable compatibility mode
  * feat: Add immutable system support(Influence: immutable)
  * fix: enable keep auth / add install check(Influence: immutable)

 -- renbin <renbin@uniontech.com>  Fri, 15 Nov 2024 13:18:28 +0800

## deepin-deb-installer 6.5.23

=== debian/changelog ===
deepin-deb-installer (6.5.23) unstable; urgency=medium

  * update translations.

 -- Liuyangming <liuyangming@uniontech.com>  Thu, 26 Jun 2025 14:02:22 +0800

deepin-deb-installer (6.5.22) unstable; urgency=medium

  * chore: Update deepin-manual resources

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Mon, 23 Jun 2025 16:27:12 +0800

deepin-deb-installer (6.5.21) unstable; urgency=medium

  * update translations.

 -- Liuyangming <liuyangming@uniontech.com>  Mon, 23 Jun 2025 13:40:31 +0800

deepin-deb-installer (6.5.20) unstable; urgency=medium

  * Add compiler flags. 

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Wed, 18 Jun 2025 10:47:29 +0800

deepin-deb-installer (6.5.19) unstable; urgency=medium

  * Update version to 6.5.19.

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Tue, 17 Jun 2025 17:35:26 +0800

## deepin-deb-installer 6.5.25

=== debian/changelog ===
deepin-deb-installer (6.5.25) unstable; urgency=medium

  * chore: Update the help manual

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 10 Jul 2025 19:51:47 +0800

deepin-deb-installer (6.5.24) unstable; urgency=medium

  * update version to 6.5.24. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Tue, 01 Jul 2025 20:34:52 +0800

## deepin-deb-installer 6.5.27

=== debian/changelog ===
deepin-deb-installer (6.5.27) unstable; urgency=medium

  * feat: Update translations for Lao locale (#350)

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Wed, 13 Aug 2025 18:01:51 +0800

deepin-deb-installer (6.5.26) unstable; urgency=medium

  * Update version to 6.5.26. 

 -- Tian ShiLin <tianshilin@uniontech.com>  Thu, 07 Aug 2025 17:46:18 +0800
